'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _pullAt2 = require('lodash/pullAt');

var _pullAt3 = _interopRequireDefault(_pullAt2);

var _concat2 = require('lodash/concat');

var _concat3 = _interopRequireDefault(_concat2);

var _startsWith2 = require('lodash/startsWith');

var _startsWith3 = _interopRequireDefault(_startsWith2);

var _some2 = require('lodash/some');

var _some3 = _interopRequireDefault(_some2);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _class, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _FormField2 = require('./FormField');

var _FormField3 = _interopRequireDefault(_FormField2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Autocomplete = (_temp2 = _class = function (_FormField) {
  _inherits(Autocomplete, _FormField);

  function Autocomplete() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Autocomplete);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Autocomplete.__proto__ || Object.getPrototypeOf(Autocomplete)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      selectedOptions: [],
      filteredOptions: _this.props.sortAlphabetically && _this.props.options ? _this.props.options.sort() : _this.props.options || [],
      isOpen: false
    }, _this.focus = function () {
      return _this.handleAutocompleteClick();
    }, _this.openOptions = function () {
      _this.setState({ isOpen: true });
    }, _this.closeOptions = function () {
      _this.setState({ isOpen: false });
    }, _this.handleAutocompleteClick = function () {
      _this._getInputSkinPart().focus();
      if (!_this.state.isOpen) {
        _this.openOptions();
      } else {
        _this.closeOptions();
      }
    }, _this.onKeyDown = function (event) {
      var selectedOptions = _this.state.selectedOptions;

      // Delete on backspace

      if (event.keyCode === 8 && !event.target.value && selectedOptions.length) {
        // Remove last selected option
        _this.removeOption(selectedOptions.length - 1, event);
      } else {
        _this.openOptions();
      }
    }, _this.clearInvalidChars = function (event) {
      var value = event.target.value;

      if (_this.props.invalidCharsRegex.test(value)) {
        event.target.value = value.replace(_this.props.invalidCharsRegex, '');
        return;
      }

      var filteredOptions = [];
      (0, _some3.default)(_this.props.options, function (option) {
        if ((0, _startsWith3.default)(option, value)) {
          filteredOptions.push(option);
        }
      });

      _this.setState({ filteredOptions: value !== '' ? filteredOptions : _this.props.options });
    }, _this.handleChange = function (option, event) {
      _this.updateSelectedOptions(event, option);
    }, _this.updateSelectedOptions = function (event) {
      var selectedOption = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

      var canMoreOptionsBeSelected = _this.state.selectedOptions.length < _this.props.maxSelections;
      var areFilteredOptionsAvailable = _this.state.filteredOptions && _this.state.filteredOptions.length > 0;

      if (!_this.props.maxSelections || canMoreOptionsBeSelected && areFilteredOptionsAvailable) {
        if (!selectedOption) return;
        var option = selectedOption.trim();
        var optionCanBeSelected = _this.state.selectedOptions.indexOf(option) < 0 && !_this.props.multipleSameSelections || _this.props.multipleSameSelections;

        if (option && optionCanBeSelected && _this.state.isOpen) {
          var selectedOptions = (0, _concat3.default)(_this.state.selectedOptions, option);
          _this.selectionChanged(selectedOptions, event);
          _this.setState({ selectedOptions: selectedOptions, isOpen: false });
        }
      }

      var input = _this._getInputSkinPart();
      input.value = '';
    }, _this.removeOption = function (index, event) {
      var selectedOptions = _this.state.selectedOptions;
      (0, _pullAt3.default)(selectedOptions, index);
      _this.selectionChanged(selectedOptions, event);
      _this.setState({ selectedOptions: selectedOptions });
    }, _this.selectionChanged = function (selectedOptions, event) {
      if (_this.props.onChange) _this.props.onChange(selectedOptions, event);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Autocomplete, [{
    key: 'prepareSkinProps',
    value: function prepareSkinProps(props) {
      var _state = this.state,
          selectedOptions = _state.selectedOptions,
          filteredOptions = _state.filteredOptions,
          isOpen = _state.isOpen;

      return Object.assign({}, _get(Autocomplete.prototype.__proto__ || Object.getPrototypeOf(Autocomplete.prototype), 'prepareSkinProps', this).call(this, props), {
        selectedOptions: selectedOptions,
        filteredOptions: filteredOptions,
        isOpen: isOpen
      });
    }

    // onKeyUp handler

  }, {
    key: '_getInputSkinPart',
    value: function _getInputSkinPart() {
      return this.skinParts[Autocomplete.SKIN_PARTS.INPUT];
    }
  }]);

  return Autocomplete;
}(_FormField3.default), _class.SKIN_PARTS = {
  ROOT: 'root',
  INPUT: 'input'
}, _class.propTypes = Object.assign({}, _FormField3.default.propTypes, {
  error: _propTypes2.default.string,
  maxSelections: _propTypes2.default.number,
  placeholder: _propTypes2.default.string,
  options: _propTypes2.default.array,
  sortAlphabetically: _propTypes2.default.bool,
  multipleSameSelections: _propTypes2.default.bool,
  maxVisibleOptions: _propTypes2.default.number,
  invalidCharsRegex: _propTypes2.default.instanceOf(RegExp)
}), _class.defaultProps = {
  maxVisibleOptions: 10, // max number of visible options
  multipleSameSelections: true, // if true then same word can be selected multiple times
  sortAlphabetically: true, // options are sorted alphabetically by default
  invalidCharsRegex: /[^a-zA-Z0-9]/g // only allow letters and numbers by default
}, _temp2);
exports.default = Autocomplete;
//# sourceMappingURL=Autocomplete.js.map