'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _class, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Input2 = require('./Input');

var _Input3 = _interopRequireDefault(_Input2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TextArea = (_temp2 = _class = function (_Input) {
  _inherits(TextArea, _Input);

  function TextArea() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, TextArea);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = TextArea.__proto__ || Object.getPrototypeOf(TextArea)).call.apply(_ref, [this].concat(args))), _this), _this.focus = function () {
      return _this.skinParts[TextArea.SKIN_PARTS.TEXT_AREA].focus();
    }, _this._handleAutoresize = function () {
      var element = _this.skinParts[TextArea.SKIN_PARTS.TEXT_AREA];
      if (!element) return;

      // compute the height difference between inner height and outer height
      var style = getComputedStyle(element, null);
      var heightOffset = style.boxSizing === 'content-box' ? -(parseFloat(style.paddingTop) + parseFloat(style.paddingBottom)) : parseFloat(style.borderTopWidth) + parseFloat(style.borderBottomWidth);

      // resize the input to its content size
      element.style.height = 'auto';
      element.style.height = element.scrollHeight + heightOffset + 'px';
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(TextArea, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      if (this.props.autoResize) {
        window.addEventListener('resize', this._handleAutoresize);
        this._handleAutoresize();
      }
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      if (this.props.autoResize) this._handleAutoresize();
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (!this.props.autoResize && nextProps.autoResize) {
        window.addEventListener('resize', this._handleAutoresize);
      } else if (this.props.autoResize && !nextProps.autoResize) {
        window.removeEventListener('resize', this._handleAutoresize);
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      if (this.props.autoResize) {
        window.removeEventListener('resize', this._handleAutoresize);
      }
    }
  }, {
    key: 'registerSkinPart',
    value: function registerSkinPart(element) {
      _get(TextArea.prototype.__proto__ || Object.getPrototypeOf(TextArea.prototype), 'registerSkinPart', this).call(this, element);
      this._handleAutoresize();
    }
  }]);

  return TextArea;
}(_Input3.default), _class.SKIN_PARTS = {
  TEXT_AREA: 'textarea'
}, _class.propTypes = Object.assign({}, _Input3.default.propTypes, {
  autoResize: _propTypes2.default.bool,
  rows: _propTypes2.default.number
}), _class.defaultProps = Object.assign({}, _Input3.default.defaultProps, {
  autoResize: true
}), _temp2);
exports.default = TextArea;
//# sourceMappingURL=TextArea.js.map