'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _reactCssThemr = require('react-css-themr');

var _identifiers = require('../identifiers');

var _Options = require('../../../components/Options');

var _Options2 = _interopRequireDefault(_Options);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = (0, _reactCssThemr.themr)(_identifiers.OPTIONS)(function (props) {
  var component = props.component,
      theme = props.theme,
      options = props.options,
      optionRenderer = props.optionRenderer,
      isOpeningUpward = props.isOpeningUpward,
      isOpen = props.isOpen,
      noResults = props.noResults,
      noResultsMessage = props.noResultsMessage;

  var highlightedOptionIndex = component.getHighlightedOptionIndex();
  var isFirstOptionHighlighted = highlightedOptionIndex === 0;
  var sortedOptions = isOpeningUpward ? options.slice().reverse() : options;
  return _react2.default.createElement(
    'ul',
    {
      className: (0, _classnames2.default)([theme.options, isOpen ? theme.isOpen : null, isFirstOptionHighlighted && !noResults ? theme.firstOptionHighlighted : null, isOpeningUpward ? theme.openUpward : null]),
      style: props.position && {
        top: props.position.positionY,
        left: props.position.positionX,
        width: props.position.width
      },
      ref: function ref(element) {
        return component.registerSkinPart(_Options2.default.SKIN_PARTS.OPTIONS, element);
      }
    },
    !noResults ? sortedOptions.map(function (option, index) {
      return _react2.default.createElement(
        'li',
        {
          key: index,
          className: (0, _classnames2.default)([theme.option, component.isHighlightedOption(index) ? theme.highlightedOption : null, option.isDisabled ? theme.disabledOption : null]),
          onClick: function onClick(event) {
            return component.handleClickOnOption(option, event);
          },
          onMouseEnter: function onMouseEnter() {
            return component.setHighlightedOptionIndex(index);
          }
        },
        optionRenderer ? optionRenderer(option) : (typeof option === 'undefined' ? 'undefined' : _typeof(option)) === 'object' ? option.label : option
      );
    }) : _react2.default.createElement(
      'li',
      { className: theme.option },
      noResultsMessage
    )
  );
});
//# sourceMappingURL=OptionsSkin.js.map